All of lore.kernel.org
 help / color / mirror / Atom feed
From: Anand Jain <anand.jain@oracle.com>
To: fstests@vger.kernel.org
Cc: linux-btrfs@vger.kernel.org
Subject: [PATCH 07/12] btrfs: check if cloned device mounts with tempfsid
Date: Thu, 15 Feb 2024 14:34:10 +0800	[thread overview]
Message-ID: <7b0f9a055c331aba64405adf60f616c5922c90a5.1707969354.git.anand.jain@oracle.com> (raw)
In-Reply-To: <cover.1707969354.git.anand.jain@oracle.com>

If another device with the same fsid and uuid would mount then verify if
it mounts with a temporary fsid.

Signed-off-by: Anand Jain <anand.jain@oracle.com>
---
 tests/btrfs/312     | 67 +++++++++++++++++++++++++++++++++++++++++++++
 tests/btrfs/312.out | 19 +++++++++++++
 2 files changed, 86 insertions(+)
 create mode 100755 tests/btrfs/312
 create mode 100644 tests/btrfs/312.out

diff --git a/tests/btrfs/312 b/tests/btrfs/312
new file mode 100755
index 000000000000..782490b1c62f
--- /dev/null
+++ b/tests/btrfs/312
@@ -0,0 +1,67 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2024 Oracle.  All Rights Reserved.
+#
+# FS QA Test 312
+#
+# On a clone a device check to see if tempfsid is activated.
+#
+. ./common/preamble
+_begin_fstest auto quick tempfsid
+
+_cleanup()
+{
+	cd /
+	umount $mnt1 > /dev/null 2>&1
+	rm -r -f $tmp.*
+	rm -r -f $mnt1
+}
+
+. ./common/filter.btrfs
+. ./common/reflink
+
+_supported_fs btrfs
+_require_btrfs_sysfs_fsid
+_require_btrfs_fs_feature temp_fsid
+_require_btrfs_command inspect-internal dump-super
+_require_scratch_dev_pool 2
+_scratch_dev_pool_get 2
+
+mnt1=$TEST_DIR/$seq/mnt1
+mkdir -p $mnt1
+
+mount_cloned_device()
+{
+	local ret
+
+	echo ---- $FUNCNAME ----
+	create_cloned_devices ${SCRATCH_DEV_NAME[0]} ${SCRATCH_DEV_NAME[1]}
+
+	echo Mounting original device
+	_mount ${SCRATCH_DEV_NAME[0]} $SCRATCH_MNT
+	$XFS_IO_PROG -fc 'pwrite -S 0x61 0 9000' $SCRATCH_MNT/foo | \
+								_filter_xfs_io
+	check_fsid ${SCRATCH_DEV_NAME[0]}
+
+	echo Mounting cloned device
+	_mount ${SCRATCH_DEV_NAME[1]} $mnt1 || \
+				_fail "mount failed, tempfsid didn't work"
+
+	echo cp reflink must fail
+	_cp_reflink $SCRATCH_MNT/foo $mnt1/bar > $tmp.cp.out 2>&1
+	ret=$?
+	cat $tmp.cp.out | _filter_testdir_and_scratch
+	if [ $ret -ne 1 ]; then
+		_fail "reflink failed to fail"
+	fi
+
+	check_fsid ${SCRATCH_DEV_NAME[1]}
+}
+
+mount_cloned_device
+
+_scratch_dev_pool_put
+
+# success, all done
+status=0
+exit
diff --git a/tests/btrfs/312.out b/tests/btrfs/312.out
new file mode 100644
index 000000000000..b7de6ce3cc6e
--- /dev/null
+++ b/tests/btrfs/312.out
@@ -0,0 +1,19 @@
+QA output created by 312
+---- mount_cloned_device ----
+Creating cloned device...wrote 9000/9000 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+done
+Mounting original device
+wrote 9000/9000 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+On disk fsid:		FSID
+Metadata uuid:		FSID
+Temp fsid:		FSID
+Tempfsid status:	0
+Mounting cloned device
+cp reflink must fail
+cp: failed to clone 'TEST_DIR/312/mnt1/bar' from 'SCRATCH_MNT/foo': Invalid cross-device link
+On disk fsid:		FSID
+Metadata uuid:		FSID
+Temp fsid:		TEMPFSID
+Tempfsid status:	1
-- 
2.39.3


  parent reply	other threads:[~2024-02-15  6:35 UTC|newest]

Thread overview: 32+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2024-02-15  6:34 [PATCH 00/12] btrfs: functional test cases for tempfsid Anand Jain
2024-02-15  6:34 ` [PATCH 01/12] add t_reflink_read_race to .gitignore file Anand Jain
2024-02-15 11:45   ` Filipe Manana
2024-02-15 11:50     ` Anand Jain
2024-02-15  6:34 ` [PATCH 02/12] assign SCRATCH_DEV_POOL to an array Anand Jain
2024-02-15 11:55   ` Filipe Manana
2024-02-15  6:34 ` [PATCH 03/12] btrfs: introduce tempfsid test group Anand Jain
2024-02-15 11:57   ` Filipe Manana
2024-02-15  6:34 ` [PATCH 04/12] btrfs: create a helper function, check_fsid(), to verify the tempfsid Anand Jain
2024-02-15 12:13   ` Filipe Manana
2024-02-16 15:02   ` Zorro Lang
2024-02-15  6:34 ` [PATCH 05/12] btrfs: verify that subvolume mounts are unaffected by tempfsid Anand Jain
2024-02-15 12:20   ` Filipe Manana
2024-02-15  6:34 ` [PATCH 06/12] create a helper to clone devices Anand Jain
2024-02-15 12:27   ` Filipe Manana
2024-02-15  6:34 ` Anand Jain [this message]
2024-02-15 12:33   ` [PATCH 07/12] btrfs: check if cloned device mounts with tempfsid Filipe Manana
2024-02-15  6:34 ` [PATCH 08/12] btrfs: test case prerequisite _require_btrfs_mkfs_uuid_option Anand Jain
2024-02-15 12:37   ` Filipe Manana
2024-02-15  6:34 ` [PATCH 09/12] btrfs: introduce helper for creating cloned devices with mkfs Anand Jain
2024-02-15 12:42   ` Filipe Manana
2024-02-17  4:31     ` Anand Jain
2024-02-15  6:34 ` [PATCH 10/12] btrfs: verify tempfsid clones using mkfs Anand Jain
2024-02-15 12:46   ` Filipe Manana
2024-02-15  6:34 ` [PATCH 11/12] btrfs: validate send-receive operation with tempfsid Anand Jain
2024-02-15 12:56   ` Filipe Manana
2024-02-15  6:34 ` [PATCH 12/12] btrfs: test tempfsid with device add, seed, and balance Anand Jain
2024-02-15 13:03   ` Filipe Manana
2024-02-19 13:18     ` Anand Jain
2024-02-19 13:29       ` Filipe Manana
2024-02-19 13:33         ` Anand Jain
2024-02-19 19:47 ` [PATCH 00/12] btrfs: functional test cases for tempfsid Anand Jain

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=7b0f9a055c331aba64405adf60f616c5922c90a5.1707969354.git.anand.jain@oracle.com \
    --to=anand.jain@oracle.com \
    --cc=fstests@vger.kernel.org \
    --cc=linux-btrfs@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.